<?php

namespace STM\Match\Lineup;

use \Exception;
use STM\StmFactory;

/**
 * Test class for MatchPlayerValidator.
 * Generated by PHPUnit on 2012-07-11 at 12:51:45.
 * @group match_lineup
 */
class MatchPlayerValidatorTest extends \PHPUnit_Framework_TestCase {

    private $valid_create_structure;

    protected function setUp() {
        $this->valid_create_structure = array(
            'match' => StmFactory::find()->Match->findById (1),
            'team_player' => StmFactory::find()->TeamMember->findById(1),
            'position' => StmFactory::find()->PersonPosition->findById(1),
            'minute_in' => '0',
            'minute_out' => '90',
            'id_substitution_player' => '',
        );
    }

    public function testCheck_create() {
        // array must have all required keys
        $this->assert_bad_arguments('checkCreate', array('match' => 1, 'team_player' => 2));
        // match must be instanceof Match
        $this->assert_bad_arguments('checkCreate', $this->get_modified_create_structure('match', null));
        // team player must be instanceof TeamMemvber
        $this->assert_bad_arguments('checkCreate', $this->get_modified_create_structure('team_player', -1));
        // _position must be instanceof PersonPosition
        $this->assert_bad_arguments('checkCreate', $this->get_modified_create_structure('position', new Exception()));
        // minute must string <0,20>
        $this->assert_bad_arguments('checkCreate', $this->get_modified_create_structure('minute_in', new Exception()));
        $this->assert_bad_arguments('checkCreate', $this->get_modified_create_structure('minute_out', '1234567890123456789012'));
        // id_substitution_player must be valid or empty
        $this->assert_bad_arguments('checkCreate', $this->get_modified_create_structure('id_substitution_player', -1));
    }

    public function testCheck_update() {
        $match_player = StmFactory::find()->MatchPlayer->findById(1);
        if ($match_player) {
            // player must be set
            $this->assert_bad_arguments('checkUpdate', $this->valid_create_structure);
            MatchPlayerValidator::setMatchPlayer($match_player);
            // at least one value must be different from current value
            $detailArray = $match_player->toArray();
            $attributes = array(
                'id_position' => $match_player->getIdPosition(),
                'minute_in' => $detailArray['minute_in'],
                'minute_out' => $detailArray['minute_out'],
                'id_substitution_player' => $match_player->getIdSubstitutionPlayer(),
            );
            $this->assert_bad_arguments('checkUpdate', $attributes);
            // substitution player must be different
            if ($match_player->getIdSubstitutionPlayer()) {
                $attributes['id_substitution_player'] = $match_player->getIdMatchPlayer();
                $this->assert_bad_arguments('checkUpdate', $attributes);
            }
        }
    }

    private function get_modified_create_structure($key, $new_value) {
        $attributes = $this->valid_create_structure;
        $attributes[$key] = $new_value;
        return $attributes;
    }

    private function assert_bad_arguments($method, $data) {
        MatchPlayerValidator::init();
        parent::assertFalse(MatchPlayerValidator::$method($data));
        MatchPlayerValidator::init();
    }

}

?>